HDU 3410 Passing the Message 三种方法(暴力,单调栈,线段树+DFS)

Passing the Message
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1283 Accepted Submission(s): 836

Problem Description
What a sunny day! Let’s go picnic and have barbecue! Today, all kids in “Sun Flower” kindergarten are prepared to have an excursion. Before kicking off, teacher Liu tells them to stand in a row. Teacher Liu has an important message to announce, but she doesn’t want to tell them directly. She just wants the message to spread among the kids by one telling another. As you know, kids may not retell the message exactly the same as what they was told, so teacher Liu wants to see how many versions of message will come out at last. With the result, she can evaluate the communication skills of those kids.
Because all kids have different height, Teacher Liu set some message passing rules as below:

1.She tells the message to the tallest kid.

2.Every kid who gets the message must retell the message to his “left messenger” and “right messenger”.

3.A kid’s “left messenger” is the kid’s tallest “left follower”.

4.A kid’s “left follower” is another kid who is on his left, shorter than him, and can be seen by him. Of course, a kid may have more than one “left follower”.

5.When a kid looks left, he can only see as far as the nearest kid who is taller than him.

The definition of “right messenger” is similar to the definition of “left messenger” except all words “left” should be replaced by words “right”.

For example, suppose the height of all kids in the row is 4, 1, 6, 3, 5, 2 (in left to right order). In this situation , teacher Liu tells the message to the 3rd kid, then the 3rd kid passes the message to the 1st kid who is his “left messenger” and the 5th kid who is his “right messenger”, and then the 1st kid tells the 2nd kid as well as the 5th kid tells the 4th kid and the 6th kid.
Your task is just to figure out the message passing route.

Input
The first line contains an integer T indicating the number of test cases, and then T test cases follows.
Each test case consists of two lines. The first line is an integer N (0< N <= 50000) which represents the number of kids. The second line lists the height of all kids, in left to right order. It is guaranteed that every kid’s height is unique and less than 2^31 – 1 .

Output
For each test case, print “Case t:” at first ( t is the case No. starting from 1 ). Then print N lines. The ith line contains two integers which indicate the position of the ith (i starts form 1 ) kid’s “left messenger” and “right messenger”. If a kid has no “left messenger” or “right messenger”, print ‘0’ instead. (The position of the leftmost kid is 1, and the position of the rightmost kid is N)

Sample Input
2
5
5 2 4 3 1
5
2 1 4 3 5

Sample Output
Case 1:
0 3
0 0
2 4
0 5
0 0
Case 2:
0 2
0 0
1 4
0 0
3 0

题意:
一群学生站在一排,他们的身高各不相同,刘老师要将消息传达给所有学生,规则如下:
首先,刘老师会把消息告诉学生中身高最高的同学,然后这位同学会将这个消息传达给左边与右边仅次于自己身高的同学,这样进行下去,直至将消息传给所有学生。在传递过程中,不能越过比自己身高还要高的同学进行传递。

思路:

线段树+DFS

看别人的题解都是用单调栈写的,但是由于自己不会单调栈,所有就用自己的方法写的。不过…,这道题学弟居然还可以用暴力过了!学弟牛逼!!

我们可以将这个身高序列分成左右两部分,从[1,n]中查找身高最高的同学x,那么他下一个传递的必然是[1,x-1]和[x+1,n]中,然后再查找区间[1,x-1]的最大值x1,[x+1,n]的最大值x2,那么x1为x的左信使,x2为x的右信使。然后再按照这种方法查找x1,x2的左右信使。

首先用线段树维护区间的最大值,然后DFS递归查找区间即可。

#include<bits/stdc++.h>
using namespace std;
#define lson (rt<<1)
#define rson ((rt<<1)|1)
const int MAXN = 51000;
struct NODE
{
    int l,r;
}a[MAXN];
int n;
int tree[MAXN<<2],cnt,maxn;
map<int,int>mp;

void init() ///初始化
{
    for(int i=0;i<=n;i++)   a[i].l=0,a[i].r=0;
    memset(tree,0,sizeof(tree));
    cnt=0;
    maxn=0;
    mp.clear();
}

void build(int rt,int L,int R)  ///建树
{
    if(L == R){
        scanf("%d",&tree[rt]);
        cnt++;
        mp[tree[rt]]=cnt;
        return ;
    }
    int Mid = (L+R)>>1;
    build(lson,L,Mid);
    build(rson,Mid+1,R);
    tree[rt]=max(tree[lson],tree[rson]);
}

void query(int rt,int L,int R,int l,int r)  ///区间查找最大值
{
    if(l<=L&&R<=r){
        maxn=max(tree[rt],maxn);
        return ;
    }
    int Mid = (L+R)>>1;
    if(l<=Mid)  query(lson,L,Mid,l,r);
    if(Mid<r)   query(rson,Mid+1,R,l,r);
}

int DFS(int l,int r)
{
    if(l>r) return 0;   ///若没有查找到信使,返回0
    maxn=0;
    query(1,1,n,l,r);
    int x=mp[maxn]; ///当前区间的信使x
    a[x].l=DFS(l,x-1);  ///左区间
    a[x].r=DFS(x+1,r);  ///右区间
    return x;   ///返回当前信使
}

int main()
{
    int T,cas=0;
    scanf("%d",&T);
    while(T--){
        init();
        scanf("%d",&n);
        build(1,1,n);
        query(1,1,n,1,n);
        int x=mp[maxn];
        a[x].l=DFS(1,x-1);
        a[x].r=DFS(x+1,n);
        cout<<"Case "<<++cas<<":"<<endl;
        for(int i=1;i<=n;i++){
            printf("%d %d\n",a[i].l,a[i].r);
        }
    }
    return 0;
}

暴力

思路:
直接暴力找左右区间比自己小的最大值即可,遇到大于自己的跳出。

#include<iostream>
#include<algorithm>
using namespace std;
const int N = 50000 + 5;

int arr[N];
bool vis[N];
int tmp[N][2];
int n;

void init(){

	for (int i = 1; i <= n; i++) vis[i] = false;
}


int main(){

	ios::sync_with_stdio(false);
	cin.tie(0);

	int T;
	cin >> T;

	for (int i = 1; i <= T; i++){

		init();

		cin >> n;

		for (int j = 1; j <= n; j++) cin >> arr[j];

		int len = 1;
		int tmp1 = -1;
		int key = 0;

		for (int p = 1; p <= n; p++){
			len = 1;
			tmp1 = -1;
			key = -1;

			while (1){

				if (p - len >= 1){
					if (arr[p - len] > arr[p]) break;

					if (arr[p - len] < arr[p] && !vis[p - len] && tmp1 < arr[p -len]){
						
							tmp1 = arr[p - len];
							key = p - len;
						
					}
				}
				else break;

				len++;
			}

			
			if (key != -1){
				tmp[p][0] = key;
				vis[key] = true;
			}
			else tmp[p][0] = 0;
			
			len = 1;
			tmp1 = -1;
			key = -1;

			while (1){
				if (p + len <= n){
					if (arr[p + len] > arr[p]) break;

					if (arr[p + len] < arr[p] && !vis[p + len] && tmp1 < arr[p + len]){

							tmp1 = arr[p + len];
							key = p + len;
					}
				}
				else break;

				len++;
			}

			if (key != -1){
				tmp[p][1] = key;
				vis[key] = true;
			}
			else tmp[p][1] = 0;
		}

		cout << "Case " << i << ":\n";

		for (int i = 1; i <= n; i++){
			cout << tmp[i][0] << " " << tmp[i][1] << endl;
		}

	}


	return 0;
}

单调栈

这道题用单调栈写的很多,就不多说了!!

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
 
using namespace std;
int T,N;
int a[50005];
int lef[50005];
int rig[50005];
int que[50005];

void init()
{
    memset(que,0,sizeof(que));
    memset(lef,0,sizeof(lef));
    memset(rig,0,sizeof(rig));
}
 
int main()
{
    scanf("%d",&T);
    int cas=0;
    while(T--){
        scanf("%d",&N);
        for(int i=1;i<=N;i++){
            scanf("%d",&a[i]);
        }
        int s=1,t=1;
        for(int i=1;i<=N;i++){
            while(t>s&&a[que[t-1]]<=a[i]) t--;
            que[t++]=i;
            if(t>s+1){
                rig[que[t-2]]=que[t-1];
            }
        }
        memset(que,0,sizeof(que));
        s=1,t=1;
        for(int i=N;i>=1;i--){
            while(t>s&&a[que[t-1]]<=a[i]) t--;
            que[t++]=i;
            if(t>s+1){
                lef[que[t-2]]=que[t-1];
            }
        }
        printf("Case %d:\n",++cas);
        for(int i=1;i<=N;i++){
            printf("%d %d\n",lef[i],rig[i]);
        }
    }
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值